<?php
/*
Plugin Name: Child Text Widget
Plugin URI: http://www.itscanfixthat.com/web-design/wordpress/custom-plugins/child-text-widget/
Description: A text widget which allows the user to choose a page for it to be a child of. The widget will only show on that page and all child pages.
Version: 1.4
Author: Michael Flynn, ITS Alaska
Author URI: http://www.itscanfixthat.com
License: GPL2
*/

add_action('init', 'child_text_widget_multi_register');
function child_text_widget_multi_register() {
 
	$prefix = 'child-text-widget'; // $id prefix
	$widget_name = "child_text_widget";
	$name = __('Child Text Widget');
	$widget_ops = array('classname' => $widget_name.'_multi', 'description' => __('A text widget which allows the user to choose a page for it to be a child of. The widget will only show on that page and all child pages.'));
	$control_ops = array('text' => "", 'parent' => 0, 'id_base' => $prefix);
	$options = get_option($widget_name.'_multi');
	if(isset($options[0])) unset($options[0]); 
	if(!empty($options)){
		foreach(array_keys($options) as $widget_number){
			wp_register_sidebar_widget($prefix.'-'.$widget_number, $name, $widget_name.'_multi', $widget_ops, array( 'number' => $widget_number ));
			wp_register_widget_control($prefix.'-'.$widget_number, $name, $widget_name.'_multi_control', $control_ops, array( 'number' => $widget_number ));
		}
	} else{
		$options = array();
		$widget_number = 1;
		wp_register_sidebar_widget($prefix.'-'.$widget_number, $name, $widget_name.'_multi', $widget_ops, array( 'number' => $widget_number ));
		wp_register_widget_control($prefix.'-'.$widget_number, $name, $widget_name.'_multi_control', $control_ops, array( 'number' => $widget_number ));
	}
}

function child_text_widget_multi($args, $vars = array()) {
	extract($args);
	// get widget saved options
	$prefix = 'child-text-widget'; // $id prefix
	$widget_name = "child_text_widget";
	$widget_number = (int)str_replace($prefix.'-', '', @$widget_id);
	$options = get_option($widget_name.'_multi');
	if(!empty($options[$widget_number])){
		$vars = $options[$widget_number];
	}
	$dpage = @get_page();
	$ancestors = (array) $dpage->ancestors;
	$show = false;
	if($dpage->ID == $vars['parent']) $show = true;
	foreach($ancestors as $key =>  $id){
		if($id == $vars['parent']) $show = true;	
	}
	if($show){
		echo $before_widget;
		if(!empty($vars['title'])){
			echo $before_title . $vars['title'] . $after_title;
		}
		echo stripslashes(stripslashes(stripslashes($vars['text'])));
		echo $after_widget;
	}
}
function child_text_widget_multi_control($args) { 
	$prefix = 'child-text-widget'; // $id prefix
	$widget_name = "child_text_widget";
	$options = get_option($widget_name.'_multi');
	if(empty($options)) $options = array();
	if(isset($options[0])) unset($options[0]);
	// update options array
	if(!empty($_POST[$prefix]) && is_array($_POST)){
		foreach($_POST[$prefix] as $widget_number => $values){
			if(empty($values) && isset($options[$widget_number])) // user clicked cancel
				continue;
			if(!isset($options[$widget_number]) && $args['number'] == -1){
				$args['number'] = $widget_number;
				$options['last_number'] = $widget_number;
			}
			$options[$widget_number] = $values;
			foreach($options[$widget_number] as $key => $val){
				if(!is_array($val)) $options[$widget_number][$key] == stripslashes(stripslashes(stripslashes($val)));
			} 
		}
		// update number
		if($args['number'] == -1 && !empty($options['last_number'])){
			$args['number'] = $options['last_number'];
		}
		// clear unused options and update options in DB. return actual options array
		$options = bf_smart_multiwidget_update($prefix, $options, $_POST[$prefix], $_POST['sidebar'], $widget_name.'_multi');
	}
	// $number - is dynamic number for multi widget, gived by WP
	// by default $number = -1 (if no widgets activated). In this case we should use %i% for inputs
	//   to allow WP generate number automatically
	$number = ($args['number'] == -1)? '%i%' : $args['number'];
	// now we can output control
	$opts = @$options[$number]; 
	$title = @$opts['title'];
	$parent = @$opts['parent'];
	$text = @$opts['text'];
	
	?>
    Title<br />
		<input type="text" name="<?php echo $prefix; ?>[<?php echo $number; ?>][title]" value="<?php echo $title; ?>" />
	  Parent<br />
		<?php wp_dropdown_pages(array('selected' => $parent, 'echo' => 1, 'name' => '<?php echo $prefix; ?>[<?php echo $number; ?>][parent]')); ?>
		Text<br />
		<textarea name="<?php echo $prefix; ?>[<?php echo $number; ?>][text]"><?php echo stripslashes(stripslashes(stripslashes($text))); ?></textarea>
	<?php
}
if(!function_exists('bf_smart_multiwidget_update')){
	function bf_smart_multiwidget_update($id_prefix, $options, $post, $sidebar, $option_name = ''){
		global $wp_registered_widgets;
		static $updated = false;
 
		// get active sidebar
		$sidebars_widgets = wp_get_sidebars_widgets();
		if ( isset($sidebars_widgets[$sidebar]) )
			$this_sidebar =& $sidebars_widgets[$sidebar];
		else
			$this_sidebar = array();
 
		// search unused options
		foreach ( $this_sidebar as $_widget_id ) {
			if(preg_match('/'.$id_prefix.'-([0-9]+)/i', $_widget_id, $match)){
				$widget_number = $match[1];
 
				// $_POST['widget-id'] contain current widgets set for current sidebar
				// $this_sidebar is not updated yet, so we can determine which was deleted
				if(!in_array($match[0], $_POST['widget-id'])){
					unset($options[$widget_number]);
				}
			}
		}
 
		// update database
		if(!empty($option_name)){
			update_option($option_name, $options);
			$updated = true;
		}
 
		// return updated array
		return $options;
	}
}
?>
